Name:		ceph-iscsi-cli
Version:	2.7
Release:	8%{?dist}
Summary:	CLI configuration tool to manage multiple iSCSI gateways
Group:		Applications/System
License:	GPLv3

URL:		https://github.com/ceph/ceph-iscsi-cli
Source0:	https://github.com/ceph/%{name}/archive/%{version}/%{name}-%{version}.tar.gz

Patch0001: 0001-Fix-node-addition.patch
Patch0002: 0002-gwcli-add-reconfigure-command-to-tune-various-lun-at.patch
Patch0003: 0003-gwcli-add-controls-attribute-to-disk-info-command.patch
Patch0004: 0004-Pass-int-to-LUN-RBDDev-class-for-size-arg.patch
Patch0005: 0005-Fix-printing-human-sizes.patch
Patch0006: 0006-Check-for-gw-manage-map-errors.patch
Patch0007: 0007-Replace-ring_buffer_size-instances.patch
Patch0008: 0008-Doc-that-all-ACLs-must-use-the-same-auth-type.patch
Patch0009: 0009-Add-export-help-info.patch
Patch0010: 0010-Add-host-level-auth-nochap-command.patch
Patch0011: 0011-Remove-per-client-auth-nochap-support.patch
Patch0012: 0012-Fix-image-naming-in-reconfigure-command.patch
Patch0013: 0013-Fix-client-auth-info-output.patch
Patch0014: 0014-Only-check-mapped-luns-during-deactivation.patch
Patch0015: 0015-api-disk-deactive-should-ignore-already-deactivated-.patch
Patch0016: 0016-gwcli-storage-count-is-not-a-number-when-creating-di.patch
Patch0017: 0017-rbd-target-api-disable-the-built-in-werkzeug-debugge.patch
Patch0018: 0018-gwcli-gateway-handle-unauthorized-response-codes-fro.patch
Patch0019: 0019-gateway-fixed-issues-with-ansible-export.patch

BuildArch:  noarch

BuildRequires: python-devel
BuildRequires: python-setuptools
BuildRequires: systemd

Requires: python-rtslib >= 2.1.fb64-0.1
Requires: ceph-iscsi-config >= 2.6-8
Requires: python-configshell >= 1.1
Requires: python-flask >= 0.10.1
Requires: python-requests >= 2.6
Requires: pyOpenSSL >= 0.1

%description
This package provides a CLI interface similar to the targetcli tool used to
interact with the kernel LIO subsystem. The rpm installs two components; a CLI
shell (based on configshell) and an API service called rbd-target-api.

The CLI orchestrates iscsi configuration changes through the API service
running on EACH gateway node. The API service uses the same configuration
settings file '/etc/ceph/iscsi-gateway.conf' as the rbd-target-gw service.

You should ensure that this 'conf' file is consistent across gateways for
consistent behaviour.

%prep
%setup -q 

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1

%build
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build


%install
%{__python} setup.py install --skip-build --root %{buildroot} --install-scripts %{_bindir}
mkdir -p %{buildroot}%{_unitdir}
install -m 0644 .%{_unitdir}/rbd-target-api.service %{buildroot}%{_unitdir}
mkdir -p %{buildroot}%{_mandir}/man8
install -m 0644 gwcli.8 %{buildroot}%{_mandir}/man8/
gzip %{buildroot}%{_mandir}/man8/gwcli.8

%post
/bin/systemctl --system daemon-reload &> /dev/null || :
/bin/systemctl --system enable rbd-target-api &> /dev/null || :

%files
%doc README
%doc LICENSE
%{_bindir}/gwcli
%{_bindir}/rbd-target-api
%{_unitdir}/rbd-target-api.service
%{python2_sitelib}/*
%{_mandir}/man8/gwcli.8.gz

%changelog
* Tue Oct 02 2018 Jason Dillaman <dillaman@redhat.com> 2.7-8
- gateway: fixed issues with ansible export (rhbz#1498764)
- gwcli/gateway: handle unauthorized response codes from API (rhbz#1602756)

* Mon Sep 24 2018 Jason Dillaman <dillaman@redhat.com> 2.7-7
- rbd-target-api: disable the built-in werkzeug debugger (rhbz#1632082)

* Tue Aug 21 2018 Jason Dillaman <dillaman@redhat.com> 2.7-6
- gwcli/storage: count is not a number when creating disks (rhbz#1562389)
- api: disk deactive should ignore already deactivated disk (rhbz#1562389)

* Tue Aug 14 2018 Jason Dillaman <dillaman@redhat.com> 2.7-5
- Only check mapped luns during deactivation (rhbz#1562389 rhbz#1562388)
- Fix client auth info output (rhbz#1615329)
- Fix image naming in reconfigure command (rhbz#1562388)
- Remove per client auth nochap support (rhbz#1566514)
- Add host level auth nochap command (rhbz#1566514)
- Add export help info (rhbz#1614287)
- Doc that all ACLs must use the same auth type (rhbz#1566514)
- Replace ring_buffer_size instances (rhbz#1562388)

* Wed Jul 25 2018 Jason Dillaman <dillaman@redhat.com> 2.7-4
- Check for gw manage map errors (rhbz#1602158)

* Fri Jul 13 2018 Jason Dillaman <dillaman@redhat.com> 2.7-3
- Bumped release requirement for ceph-iscsi-config

* Fri Jul 13 2018 Jason Dillaman <dillaman@redhat.com> 2.7-2
- Fix printing human sizes (rhbz#1600071)
- Pass int to LUN/RBDDev class for size arg (rhbz#1600071)
- gwcli: add "controls" attribute to disk info command (rhbz#1600071)
- gwcli: add reconfigure command to tune various lun attributes (rhbz#1600071)
- Fix node addition (rhbz#1600071)

* Sat May 7 2018 Jason Dillaman <dillaman@rehdat.com> 2.7-1
- Rebased to v2.7

* Thu Oct 05 2017 Jason Dillaman <dillaman@redhat.com> 2.5-9
- Enforce the minimum gateways setting (rhbz#1498825)
- Properly construct seed gateway list (rhbz#1498825)
- Prevent creation of more than 256 disks (rhbz#1498505)

* Wed Sep 27 2017 Jason Dillaman <dillaman@redhat.com> 2.5-8
- client auth logic updated to further validate username/password chap strings
- updated APIRequest Logic to handle connection failures
- Validate client IQN for create and delete UI actions
- Wrap JSON response decoding with exception handling
- Corrected health check summary scrap logic for Luminous

* Sun Sep 24 2017 Jason Dillaman <dillaman@redhat.com> 2.5-7
- storage: add further validation to disk create request
- storage: fix the display of capacity when adding disks
- client: fix auth workflow issue BZ 1491550
- rbd-target-api: bypass rpm checks if the platform is not redhat
- rbd-target-api: be less specific with the package checks
- rbd-target-api: health check logic and gateway validity checks updated
- gateway: gateway creation and health checks updated
- ceph: use the first mon in quorum list when exporting the config
- ceph: updated to provide more health information within the UI
- utils: added os_cmd function

* Thu Sep 14 2017 Jason Dillaman <dillaman@redhat.com> 2.5-6
- Improved systemd limits and system protection
- hostgroup: fix for disk removal from a hostgroup

* Fri Sep 08 2017 Jason Dillaman <dillaman@redhat.com> 2.5-5
- rbd-target-api: fix gateway order during device deletion request
- rbd-target-api: add image_id validation to the disk endpoint
- storage: add quick sanity check to a delete request

* Tue Sep 05 2017 Jason Dillaman <dillaman@redhat.com> 2.5-4
- gateway: added a 5sec background thread to check gateway health
- hostgroup: UI fixes
- rbd-target-api: fix issue of changes being accepted when a gateway is down

* Fri Sep 01 2017 Jason Dillaman <dillaman@redhat.com> 2.5-3
- storage: ensure create_disk issues a return value
- client: doctext update
- utils: fix 'valid_disk' logic
- rbd-target-api: fix to address a problem when deleting rbd images
- client: doc updates and added methods to support group management
- hostgroup: refactored the code, including a number of bug fixes
- rbd-target-api : minor change to make the code more readable
- node: prevent 'info' command causing an exception
- hostgroup: fetch updated group definition to refresh UI subtree
- rbd-target-api: prevent disk create requests when # gateways <2
- storage: catch invalid pool names in disk create request
- gateway: fix api call when clearing the config

* Mon Aug 28 2017 Jason Dillaman <dillaman@redhat.com> 2.5-2
- client/auth: fix special characters accepted in UI

* Tue Aug 15 2017 Jason Dillaman <dillaman@redhat.com> 2.5-1
- rebased to version 2.5

* Wed Jun 07 2017 Jason Dillaman <dillaman@redhat.com> 2.0-5
- bumped ceph-iscsi-config and python-rtslib required versions

* Wed Apr 26 2017 Jason Dillaman <dillaman@redhat.com> 2.0-4
- utils: updated console_message to change output if running in batch mode
- gwcli: add __version__ and set a flag to denote interactive/batch mode
- gateway: fix - gateways info command now uses console_msg function
- node: fix to formatting of the info command
- systemd unit: fix dependencies between gw and api services
- gateway: determine gw health using iscsi and API port states
- utils: add port state function
- client/storage: allow disks to be autodefined when managing a client
- node: add method to return UI root object
- client: after client is corrected, cd to the new definition
- systemd : add service dependencies between rbd-target-gw and rbd-target-api
- gateway: debug text changed when refreshing gw connection state
- gateway: port open check updated with a shutdown call
- gateway: Use console_message for high level info command
- gateway: fix filename used in hash compare
- rbd-target-api: remove redundant code that checked lvm.conf
- spec: changelog update
- client: decrypt client chap passwords within the CLI
- gateway: decrypt chap password when exporting for Ansible
- storage: fix - pool refresh for create/deletes
- storage: fix - disk resize now updates the pool information
- client: fix - disk resize not being picked up against mapped luns
- enable multiple ceph clusters in the UI
- client: block the addition of a duplicate LUN to a client
- add debug information to gateway and storage modules
- soft fail client init failures
- spec: updated change list
- gateway: Add UP/DOWN check for each gateway
- rbd-target-api: updated to use the renamed config file *.cfg
- spec: updated to reflect recent patches
- storage.py: Added info and resize commands to /disks subtree
- Requested command is now added to the log file
- node.py: updated generic info method
- man-page: Updated to reflect changes for TCMU, and addition of resize cmd
- node: tidy up list display for info commands
- rbd-target-api: automatically select best TLS based on werkzeug version
- spec: version bump to 2.1
- rbd-target-api: restructure to remove flask-restful dependencies
- setup: version bump to 2.1

* Fri Jan 13 2017 Jason Dillaman <dillaman@redhat.com> 2.0-3
- storage:add feature_list as a display attribute
- rbd-target-api: automatically select best TLS based on werkzeug version
- storage: convert feature int to a list of descriptions
- utils: fix - account for empty gateway group

* Wed Jan 11 2017 Jason Dillaman <dillaman@redhat.com> 2.0-2
- rbd-target-api: restructure to remove flask-restful dependencies
- node: generic ui_command_info now uses console_message function
- PEP8 import layout change
- storage: removal of dev-mapper code
- import layout changes to PEP guidelines
- utils: color message function added

* Thu Jan 5 2017 Paul Cuzner <pcuzner@redhat.com> 2.0-1
- initial rpm packaging (rhbz#1410133)


